`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/05/11 19:48:32
// Design Name: 
// Module Name: key_decoder
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`include "global.vh"

module key_to_note_decoder(
    note_result, 
    select_in,
    clk,
    rst,
    display_in_1,
    display_in_0,
    key_release
    );

    output reg [21:0] note_result;
    output reg [3:0] display_in_1, display_in_0;
    input clk, rst;
    input [6:0] select_in;
    input key_release;

    reg [21:0] result_tmp;
    reg [3:0] display_in_1_tmp, display_in_0_tmp;
    
    always @*
        case (select_in)
            `ASCII_c:
            begin
                result_tmp = `mid_do;
            end
            `ASCII_d:
            begin
                result_tmp = `mid_re;
            end
            `ASCII_e:
            begin
                result_tmp = `mid_mi;
            end
            `ASCII_f:
            begin
                result_tmp = `mid_fa;
            end
            `ASCII_g:
            begin
                result_tmp = `mid_so;
            end
            `ASCII_a:
            begin
                result_tmp = `mid_la;
            end
            `ASCII_b:
            begin
                result_tmp = `mid_si;
            end
            `ASCII_C:
            begin
                result_tmp = `high_do;
            end
            `ASCII_D:
            begin
                result_tmp = `high_re;
            end
            `ASCII_E:
            begin
                result_tmp = `high_mi;
            end
            `ASCII_F:
            begin
                result_tmp = `high_fa;
            end
            `ASCII_G:
            begin
                result_tmp = `high_so;
            end
            `ASCII_A:
            begin
                result_tmp = `high_la;
            end
            `ASCII_B:
            begin
                result_tmp = `high_si;
            end
            default:
            begin
                result_tmp = note_result;
            end 
        endcase

    always @*
        case (select_in)
            `ASCII_c:
            begin
                display_in_1_tmp = 4'd0;
                display_in_0_tmp = 4'd1;
            end
            `ASCII_d:
            begin
                display_in_1_tmp = 4'd2;
                display_in_0_tmp = 4'd3;
            end
            `ASCII_e:
            begin
                display_in_1_tmp = 4'd4;
                display_in_0_tmp = 4'd5;
            end
            `ASCII_f:
            begin
                display_in_1_tmp = 4'd6;
                display_in_0_tmp = 4'd7;
            end
            `ASCII_g:
            begin
                display_in_1_tmp = 4'd8;
                display_in_0_tmp = 4'd1;
            end
            `ASCII_a:
            begin
                display_in_1_tmp = 4'd9;
                display_in_0_tmp = 4'd7;
            end
            `ASCII_b:
            begin
                display_in_1_tmp = 4'd8;
                display_in_0_tmp = 4'd5;
            end
            `ASCII_C:
            begin
                display_in_1_tmp = 4'd0;
                display_in_0_tmp = 4'd1;
            end
            `ASCII_D:
            begin
                display_in_1_tmp = 4'd2;
                display_in_0_tmp = 4'd3;
            end
            `ASCII_E:
            begin
                display_in_1_tmp = 4'd4;
                display_in_0_tmp = 4'd5;
            end
            `ASCII_F:
            begin
                display_in_1_tmp = 4'd6;
                display_in_0_tmp = 4'd7;
            end
            `ASCII_G:
            begin
                display_in_1_tmp = 4'd8;
                display_in_0_tmp = 4'd1;
            end
            `ASCII_A:
            begin
                display_in_1_tmp = 4'd9;
                display_in_0_tmp = 4'd7;
            end
            `ASCII_B:
            begin
                display_in_1_tmp = 4'd8;
                display_in_0_tmp = 4'd5;
            end
            default:
            begin
                display_in_1_tmp = 4'd10;
                display_in_0_tmp = 4'd10;
            end 
        endcase

    always @(posedge clk or posedge rst)
        if (rst)
        begin
            note_result <= 22'd0;
            display_in_1 <= 4'd10;
            display_in_0 <= 4'd10;
        end
        else
        begin
            note_result <= result_tmp;
            display_in_1 <= display_in_1_tmp;
            display_in_0 <= display_in_0_tmp;
        end
    
endmodule




